/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 232 by dpavlin, Sun Oct 24 11:55:02 2010 UTC revision 245 by dpavlin, Tue Mar 29 18:02:44 2011 UTC
# Line 47  lxc_hostname() { Line 47  lxc_hostname() {
47  }  }
48    
49  lxc_ip() {  lxc_ip() {
50          grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 ||          ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51          grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'          grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54  }  }
55    
56  lxc_status() {  lxc_status() {
# Line 64  cleanup_init_scripts() { Line 66  cleanup_init_scripts() {
66          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
67    
68          ls \          ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
71                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
72                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
73                  $rootfs/etc/rc?.d/*udev* \                  $rootfs/etc/rc?.d/*udev* \
74                    $rootfs/etc/rc?.d/*checkfs* \
75          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
76    
77          echo $1 > $rootfs/etc/hostname          echo $1 > $rootfs/etc/hostname
78            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79  }  }
80    
81    
# Line 128  lxc_start() { Line 133  lxc_start() {
133    
134          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
135                  lxc_log "$name start"                  lxc_log "$name start"
136                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
137                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
138                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
139                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
140                  lxc-info  -n $name                  lxc-info  -n $name
# Line 142  rootfs=$(lxc_rootfs $1) Line 149  rootfs=$(lxc_rootfs $1)
149  while true; do  while true; do
150          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
151          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
152            stop_on=1 # init
153            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
154            if [ "$sulogins" -gt 0 ] ; then
155                    stop_on=`expr $stop_on + $sulogins`
156            fi
157    
158          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
159          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
160    
161                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
162                  lxc_log "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
# Line 171  while true; do Line 184  while true; do
184                  ;;                  ;;
185                  esac                  esac
186          else          else
187                  lxc_log "$name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
188          fi          fi
189    
190          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...

Legend:
Removed from v.232  
changed lines
  Added in v.245

  ViewVC Help
Powered by ViewVC 1.1.26